<template>
    <div>
        Materiel: {{resource.materiel}}<br>Reference: {{resource.reference}}
        <br>
        <hr>
        <ResourceForm v-bind:resource="resource" v-bind:providers="providers" v-on:back="back" v-on:submit="submit" v-on:remove="remove"></ResourceForm>
    </div>
</template>

<script>
import ResourceForm from '../Resources/Resources.Form.vue';
import { editProject } from '@/api/projects.service.js';
export default {
    data(){
        return {
            project:{}
        }
    },
    computed: {
        resource() {
            if (this.project && this.project.resources) {
                return this.project.resources[this.$route.params.index];
            }
            return {};
        },
        providers(){
            return this.$store.getters.getAllProviders;
        }
    },
    components: {
        ResourceForm
    },
    methods: {
        back: function() {
            this.$router.go(-1);
        },
        submit: function() {
            this.project.resources[this.$route.params.index] = this.resource;
            let id = this.project._id;
            editProject(id, this.project).then(() => {
                this.$store.dispatch('setProjectById', this.$route.params.id);
                this.$router.go(-1);
            });
        },
        remove() {
            this.project.resources.splice(this.$route.params.resourceId, 1);
            let id = this.project._id;
            editProject(id, this.project).then(() => {
                this.$store.dispatch('setProjectById', this.$route.params.id);
                this.$router.go(-1);
            });
        }
    },
    created() {
        this.$store.dispatch('setAllProviders');
        this.$store.dispatch('setProjectById', this.$route.params.id).then(data=>{
            this.project = data;
        });
    }
}
</script>

<style>

</style>
